require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&_KERNEL_OPT)) {
    require './mips/opt_param.ph';
}
if(defined(&__MIPSEB__)) {
    eval 'sub _MACHINE_SUFFIX () { &eb;}' unless defined(&_MACHINE_SUFFIX);
    eval 'sub MACHINE_SUFFIX () {"eb";}' unless defined(&MACHINE_SUFFIX);
}
 elsif(defined(&__MIPSEL__)) {
    eval 'sub _MACHINE_SUFFIX () { &el;}' unless defined(&_MACHINE_SUFFIX);
    eval 'sub MACHINE_SUFFIX () {"el";}' unless defined(&MACHINE_SUFFIX);
} else {
    die("neither\ __MIPSEL__\ nor\ __MIPSEB__\ are\ defined\.");
}
eval 'sub ___MACHINE32_OARCH () { &mips &_MACHINE_SUFFIX;}' unless defined(&___MACHINE32_OARCH);
eval 'sub __MACHINE32_OARCH () {"mips"  &MACHINE_SUFFIX;}' unless defined(&__MACHINE32_OARCH);
eval 'sub ___MACHINE32_NARCH () { &mips64 &_MACHINE_SUFFIX;}' unless defined(&___MACHINE32_NARCH);
eval 'sub __MACHINE32_NARCH () {"mips64"  &MACHINE_SUFFIX;}' unless defined(&__MACHINE32_NARCH);
eval 'sub ___MACHINE64_NARCH () { &mipsn64 &_MACHINE_SUFFIX;}' unless defined(&___MACHINE64_NARCH);
eval 'sub __MACHINE64_NARCH () {"mipsn64"  &MACHINE_SUFFIX;}' unless defined(&__MACHINE64_NARCH);
if(defined(&__mips_n32) || defined(&__mips_n64)) {
    if(defined(&__mips_n32)) {
	eval 'sub _MACHINE_ARCH () { &___MACHINE32_NARCH;}' unless defined(&_MACHINE_ARCH);
	eval 'sub MACHINE_ARCH () { &__MACHINE32_NARCH;}' unless defined(&MACHINE_ARCH);
    } else {
	eval 'sub _MACHINE_ARCH () { &___MACHINE64_NARCH;}' unless defined(&_MACHINE_ARCH);
	eval 'sub MACHINE_ARCH () { &__MACHINE64_NARCH;}' unless defined(&MACHINE_ARCH);
	eval 'sub _MACHINE32_NARCH () { &___MACHINE32_NARCH;}' unless defined(&_MACHINE32_NARCH);
	eval 'sub MACHINE32_NARCH () { &__MACHINE32_NARCH;}' unless defined(&MACHINE32_NARCH);
    }
    eval 'sub _MACHINE32_OARCH () { &___MACHINE32_OARCH;}' unless defined(&_MACHINE32_OARCH);
    eval 'sub MACHINE32_OARCH () { &__MACHINE32_OARCH;}' unless defined(&MACHINE32_OARCH);
} else {
    eval 'sub _MACHINE_ARCH () { &___MACHINE32_OARCH;}' unless defined(&_MACHINE_ARCH);
    eval 'sub MACHINE_ARCH () { &__MACHINE32_OARCH;}' unless defined(&MACHINE_ARCH);
}
unless(defined(&_KERNEL)) {
    undef(&MACHINE) if defined(&MACHINE);
    eval 'sub MACHINE () {"mips";}' unless defined(&MACHINE);
}
eval 'sub ALIGNBYTES32 () {($sizeof{\'double\'} - 1);}' unless defined(&ALIGNBYTES32);
unless(defined(&ALIGN32)) {
    sub ALIGN32 {
	my($p) = @_;
	eval q(((( &uintptr_t)($p) +  &ALIGNBYTES32) &~ &ALIGNBYTES32));
    }
}
eval 'sub SSIZE () {1;}' unless defined(&SSIZE);
eval 'sub SINCR () {1;}' unless defined(&SINCR);
if(((defined(&ENABLE_MIPS_16KB_PAGE) ? &ENABLE_MIPS_16KB_PAGE : undef) + (defined(&ENABLE_MIPS_8KB_PAGE) ? &ENABLE_MIPS_8KB_PAGE : undef) + (defined(&ENABLE_MIPS_4KB_PAGE) ? &ENABLE_MIPS_4KB_PAGE : undef)) > 1) {
    die("only\ one\ of\ ENABLE_MIPS_\{4\,8\,16\}KB_PAGE\ can\ be\ defined\.");
}
unless(defined(&MSGBUFSIZE)) {
    eval 'sub MSGBUFSIZE () { &NBPG;}' unless defined(&MSGBUFSIZE);
}
eval 'sub COHERENCY_UNIT () {128;}' unless defined(&COHERENCY_UNIT);
eval 'sub CACHE_LINE_SIZE () {128;}' unless defined(&CACHE_LINE_SIZE);
if(defined(&ENABLE_MIPS_16KB_PAGE)) {
    eval 'sub PGSHIFT () {14;}' unless defined(&PGSHIFT);
}
 elsif(defined(&ENABLE_MIPS_8KB_PAGE) || (!defined(&ENABLE_MIPS_4KB_PAGE)  && (defined(&__mips) ? &__mips : undef) >= 3)) {
    eval 'sub PGSHIFT () {13;}' unless defined(&PGSHIFT);
} else {
    eval 'sub PGSHIFT () {12;}' unless defined(&PGSHIFT);
}
eval 'sub NBPG () {(1<<  &PGSHIFT);}' unless defined(&NBPG);
eval 'sub PGOFSET () {( &NBPG - 1);}' unless defined(&PGOFSET);
eval 'sub PTPSHIFT () {2;}' unless defined(&PTPSHIFT);
eval 'sub PTPLENGTH () {( &PGSHIFT -  &PTPSHIFT);}' unless defined(&PTPLENGTH);
eval 'sub NPTEPG () {(1<<  &PTPLENGTH);}' unless defined(&NPTEPG);
eval 'sub SEGSHIFT () {( &PGSHIFT +  &PTPLENGTH);}' unless defined(&SEGSHIFT);
eval 'sub NBSEG () {(1<<  &SEGSHIFT);}' unless defined(&NBSEG);
eval 'sub SEGOFSET () {( &NBSEG - 1);}' unless defined(&SEGOFSET);
if(defined(&_LP64)) {
    eval 'sub SEGLENGTH () {( &PGSHIFT - 3);}' unless defined(&SEGLENGTH);
    eval 'sub XSEGSHIFT () {( &SEGSHIFT +  &SEGLENGTH);}' unless defined(&XSEGSHIFT);
    eval 'sub NBXSEG () {(1 <<  &XSEGSHIFT);}' unless defined(&NBXSEG);
    eval 'sub XSEGOFSET () {( &NBXSEG - 1);}' unless defined(&XSEGOFSET);
    eval 'sub XSEGLENGTH () {( &PGSHIFT - 3);}' unless defined(&XSEGLENGTH);
    eval 'sub NXSEGPG () {(1<<  &XSEGLENGTH);}' unless defined(&NXSEGPG);
} else {
    eval 'sub SEGLENGTH () {(31-  &SEGSHIFT);}' unless defined(&SEGLENGTH);
}
eval 'sub NSEGPG () {(1<<  &SEGLENGTH);}' unless defined(&NSEGPG);
if(defined(&_LP64)) {
    eval 'sub __MIN_USPACE () {16384;}' unless defined(&__MIN_USPACE);
} else {
    eval 'sub __MIN_USPACE () {8192;}' unless defined(&__MIN_USPACE);
}
eval 'sub USPACE () { &MAX( &__MIN_USPACE,  &PAGE_SIZE);}' unless defined(&USPACE);
eval 'sub UPAGES () {( &USPACE /  &PAGE_SIZE);}' unless defined(&UPAGES);
eval 'sub USPACE_ALIGN () { &USPACE;}' unless defined(&USPACE_ALIGN);
eval 'sub UPAGES_MAX () {8;}' unless defined(&UPAGES_MAX);
eval 'sub NKMEMPAGES_MIN_DEFAULT () {((8* 1024* 1024) >>  &PAGE_SHIFT);}' unless defined(&NKMEMPAGES_MIN_DEFAULT);
eval 'sub NKMEMPAGES_MAX_DEFAULT () {((128* 1024* 1024) >>  &PAGE_SHIFT);}' unless defined(&NKMEMPAGES_MAX_DEFAULT);
unless(defined(&mips_round_page)) {
    sub mips_round_page {
	my($x) = @_;
	eval q((((( &uintptr_t)($x)) +  &NBPG - 1) & ~( &NBPG-1)));
    }
}
unless(defined(&mips_trunc_page)) {
    sub mips_trunc_page {
	my($x) = @_;
	eval q((( &uintptr_t)($x) & ~( &NBPG-1)));
    }
}
unless(defined(&mips_btop)) {
    sub mips_btop {
	my($x) = @_;
	eval q((( &paddr_t)($x) >>  &PGSHIFT));
    }
}
unless(defined(&mips_ptob)) {
    sub mips_ptob {
	my($x) = @_;
	eval q((( &paddr_t)($x) <<  &PGSHIFT));
    }
}
if(defined(&__MIPSEL__)) {
    eval 'sub MID_MACHINE () { &MID_PMAX;}' unless defined(&MID_MACHINE);
}
if(defined(&__MIPSEB__)) {
    eval 'sub MID_MACHINE () { &MID_MIPS;}' unless defined(&MID_MACHINE);
}
unless(defined(&MSIZE)) {
    if(defined(&_LP64)) {
	eval 'sub MSIZE () {512;}' unless defined(&MSIZE);
    } else {
	eval 'sub MSIZE () {256;}' unless defined(&MSIZE);
    }
    unless(defined(&MCLSHIFT)) {
	eval 'sub MCLSHIFT () {11;}' unless defined(&MCLSHIFT);
    }
    eval 'sub MCLBYTES () {(1<<  &MCLSHIFT);}' unless defined(&MCLBYTES);
}
1;
